CodeForces 687A NP-Hard Problem 搜索

http://codeforces.com/problemset/problem/687/A

A. NP-Hard Problem
time limit per test2 seconds
memory limit per test256 megabytes
inputstandard input
outputstandard output
Recently, Pari and Arya did some research about NP-Hard problems and they found the minimum vertex cover problem very interesting.

Suppose the graph G is given. Subset A of its vertices is called a vertex cover of this graph, if for each edge uv there is at least one endpoint of it in this set, i.e. or (or both).

Pari and Arya have won a great undirected graph as an award in a team contest. Now they have to split it in two parts, but both of them want their parts of the graph to be a vertex cover.

They have agreed to give you their graph and you need to find two disjoint subsets of its vertices A and B, such that both A and B are vertex cover or claim it’s impossible. Each vertex should be given to no more than one of the friends (or you can even keep it for yourself).

Input
The first line of the input contains two integers n and m (2 ≤ n ≤ 100 000, 1 ≤ m ≤ 100 000) — the number of vertices and the number of edges in the prize graph, respectively.

Each of the next m lines contains a pair of integers ui and vi (1  ≤  ui,  vi  ≤  n), denoting an undirected edge between ui and vi. It’s guaranteed the graph won’t contain any self-loops or multiple edges.

Output
If it’s impossible to split the graph between Pari and Arya as they expect, print “-1” (without quotes).

If there are two disjoint sets of vertices, such that both sets are vertex cover, print their descriptions. Each description must contain two lines. The first line contains a single integer k denoting the number of vertices in that vertex cover, and the second line contains k integers — the indices of vertices. Note that because of m ≥ 1, vertex cover cannot be empty.

Examples
input
4 2
1 2
2 3
output
1
2
2
1 3
input
3 3
1 2
2 3
1 3
output
-1
Note
In the first sample, you can give the vertex number 2 to Arya and vertices numbered 1 and 3 to Pari and keep vertex number 4 for yourself (or give it someone, if you wish).

In the second sample, there is no way to satisfy both Pari and Arya.

题意:
给出一片图问能不能产生两个集合,使每一边的两点分入不同的集合。
解法:
确定一点开始搜索,如果发现下一点已赋值且与该点为同一集合,就结束遍历。

#include<map>
#include<set>
#include<queue>
#include<stack>
#include<cmath>
#include<cstdio>
#include<vector>
#include<string>
#include<fstream>
#include<cstring>
#include<ctype.h>
#include<iostream>
#include<algorithm>
#define INF (1<<30)
#define PI acos(-1.0)
const int MOD = 1000000007;
typedef long long ll;
using namespace std;
vector<int>q[100005];
int n, m;
int vis[100005];
int dfs(int x)
{
    if (vis[x] == 0)
    {
        vis[x] = 1;
    }
    for (int i = 0; i<q[x].size(); i++)
    {
        if (vis[x] == vis[q[x][i]])
        {
            return 0;
        }
        if (vis[q[x][i]] == 0)
        {
            vis[q[x][i]] = (vis[x] + 2) % 2 + 1;
            if (!dfs(q[x][i]))
            {
                return 0;
            }
        }
    }
    return 1;
}
int check()
{
    for (int i = 1; i <= n; i++)
    {
        if (!vis[i])
        {
            if (dfs(i) == 0)return 0;
        }
    }
    return 1;
}
int main()
{
    while (scanf("%d%d", &n, &m) != EOF)
    {
        for (int i = 0, a, b; i<m; i++)
        {
            scanf("%d%d", &a, &b);
            q[a].push_back(b);
            q[b].push_back(a);
        }
        if (!check())
            cout << "-1" << endl;
        else
        {
            int A = 0, B = 0;
            for (int i = 1; i<=n; i++)
            {
                if (q[i].size())
                {
                    if (vis[i] == 1)
                    {
                        A++;
                    }
                    else if (vis[i] == 2)
                    {
                        B++;
                    }
                }
            }
            cout << A << endl;
            int cnt = 0;
            for (int i = 1; i <= n; i++)
            {
                if (!q[i].size() || vis[i] == 2)
                {
                    continue;
                }
                cnt++;
                if (cnt != A)
                    cout << i << " ";
                else
                    cout << i << endl;
            }
            cnt = 0;
            cout << B << endl;
            for (int i = 1; i <= n; i++)
            {
                if (!q[i].size() || vis[i] == 1)
                {
                    continue;
                }
                cnt++;
                if (cnt != B)
                    cout << i << " ";
                else
                    cout << i << endl;
            }
        }

    }
    return 0;
}

开始时大意没有在递归时加上判断,错了一次。

1、资源项目源码均已通过严格测试验证,保证能够正常运行; 2、项目问题、技术讨论,可以给博主私信或留言,博主看到后会第一时间与您进行沟通; 3、本项目比较适合计算机领域相关的毕业设计课题、课程作业等使用,尤其对于人工智能、计算机科学与技术等相关专业,更为适合; 4、下载使用后,可先查看rEADME.md或论文文件(如有),本项目仅用作交流学习参考,请切勿用于商业用途。 5、资源来自互联网采集,如有侵权,私聊博主删除。 6、可私信博主看论文后选择购买源代码。 1、资源项目源码均已通过严格测试验证,保证能够正常运行; 2、项目问题、技术讨论,可以给博主私信或留言,博主看到后会第一时间与您进行沟通; 3、本项目比较适合计算机领域相关的毕业设计课题、课程作业等使用,尤其对于人工智能、计算机科学与技术等相关专业,更为适合; 4、下载使用后,可先查看rEADME.md或论文文件(如有),本项目仅用作交流学习参考,请切勿用于商业用途。 5、资源来自互联网采集,如有侵权,私聊博主删除。 6、可私信博主看论文后选择购买源代码。 1、资源项目源码均已通过严格测试验证,保证能够正常运行; 2、项目问题、技术讨论,可以给博主私信或留言,博主看到后会第一时间与您进行沟通; 3、本项目比较适合计算机领域相关的毕业设计课题、课程作业等使用,尤其对于人工智能、计算机科学与技术等相关专业,更为适合; 4、下载使用后,可先查看README.md或论文文件(如有),本项目仅用作交流学习参考,请切勿用于商业用途。 5、资源来自互联网采集,如有侵权,私聊博主删除。 6、可私信博主看论文后选择购买源代码。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值